package alex.carmessenger;

import android.content.Intent;
import android.support.v7.app.AppCompatActivity;
import android.os.Bundle;
import android.text.method.ScrollingMovementMethod;
import android.view.Menu;
import android.view.MenuInflater;
import android.view.MenuItem;
import android.widget.ScrollView;
import android.widget.TextView;
/*
 * Error activity class provides the error screen that users see rather than the application crashing to the desktop
 * The errors are given in a more readable way than from the android terminal. 
*/
public class ErrorActivity extends AppCompatActivity {
    TextView error;
    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_error);
        Thread.setDefaultUncaughtExceptionHandler(new ErrorHandler(this));

        error = (TextView) findViewById(R.id.error);
        error.setText(getIntent().getStringExtra("error"));
        error.setMovementMethod(new ScrollingMovementMethod());

    }

    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        MenuInflater inflater = getMenuInflater();
        inflater.inflate(R.menu.menu_actions, menu);

        return super.onCreateOptionsMenu(menu);
    }

    @Override
    public boolean onOptionsItemSelected(MenuItem item) {
        switch (item.getItemId()) {
            case R.id.action_homeButton:
                Intent mainMenuIntent = new Intent(this, MainMenu.class);
                startActivity(mainMenuIntent);
                finish();
                return true;

            case R.id.action_new_message:
                Intent sendMessageIntent = new Intent(this, sendMessage.class);
                startActivity(sendMessageIntent);
                finish();
                return true;

            case R.id.action_logout:
                Intent logoutIntent = new Intent(this, HomeScreen.class);
                startActivity(logoutIntent);
                finish();
                return true;

            default:
                // If we got here, the user's action was not recognized.
                // Invoke the superclass to handle it.
                return super.onOptionsItemSelected(item);

        }
    }
}
