package alex.carmessenger;

import android.app.Dialog;
import android.content.Context;
import android.content.Intent;
import android.content.SharedPreferences;
import android.database.Cursor;
import android.support.v7.app.AlertDialog;
import android.support.v7.app.AppCompatActivity;
import android.os.Bundle;
import android.util.Pair;
import android.view.Menu;
import android.view.MenuInflater;
import android.view.MenuItem;
import android.view.View;
import android.view.ViewGroup;
import android.widget.AdapterView;
import android.widget.Button;
import android.widget.EditText;
import android.widget.ImageView;
import android.widget.ListView;
import android.widget.RatingBar;
import android.widget.SimpleCursorAdapter;
import android.widget.TextView;
import android.widget.Toast;

public class Inbox extends AppCompatActivity {
    public DBAdapter db;
    ListView myList;
    Dialog feedbackDialog;
    Button respondToClick;
    String name;
    String regNo;
    ImageView imageHeader;
    TextView textview;
    public static final String MyPREFERENCES = "MyPrefs" ;
    SharedPreferences sharedPref;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_inbox);
        Thread.setDefaultUncaughtExceptionHandler(new ErrorHandler(this));
//        new ServletPostAsyncTask().execute(new Pair<Context, String>(this, "You have a new message"));
        textview = (TextView) findViewById(R.id.inboxDisplayUser);

        sharedPref = getSharedPreferences(MyPREFERENCES, Context.MODE_PRIVATE);
        name = sharedPref.getString(HomeScreen.username, "uniqueID");
        textview.setText(name);
        respondToClick =  (Button)findViewById(R.id.customDialogFeedbackButton);
        imageHeader = (ImageView)findViewById(R.id.inboxTitleImage);

        db = new DBAdapter(this);
        db.open();
//        String regNo = db.getRegNo(name);
//
//        Toast.makeText(Inbox.this, regNo, Toast.LENGTH_SHORT).show();
//        populateListView();
        Button findMessages = (Button) findViewById(R.id.inboxDisplayAllRecords);
        findMessages.setOnClickListener(new View.OnClickListener() {
            public void onClick(View v) {
                populateListView();
            }
        });

        imageHeader.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                menu(v);
            }
        });

    }

    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        MenuInflater inflater = getMenuInflater();
        inflater.inflate(R.menu.menu_actions, menu);

        return super.onCreateOptionsMenu(menu);
    }
    @Override
    public boolean onOptionsItemSelected(MenuItem item) {
        switch (item.getItemId()) {
            case R.id.action_homeButton:
                Intent mainMenuIntent = new Intent(this, MainMenu.class);
                startActivity(mainMenuIntent);
                finish();
                return true;

            case R.id.action_new_message:
                Intent sendMessageIntent = new Intent(this, sendMessage.class);
                startActivity(sendMessageIntent);
                finish();
                return true;

            case R.id.action_logout:
                Intent logoutIntent = new Intent(this, HomeScreen.class);
                startActivity(logoutIntent);
                finish();
                return true;

            default:
                // If we got here, the user's action was not recognized.
                // Invoke the superclass to handle it.
                return super.onOptionsItemSelected(item);

        }
    }
    /*
     * Retrieves the messages for the user who is logged into the application from the database. 
     * Uses functions from the DBAdapter class to pull the information into a custom list view that is used to display
     * the records retrieved from the database. 
    */
    private void populateListView() {
        regNo = db.getRegNo(name);
        Cursor cursor = db.getAllRows(regNo);
        if(cursor != null){
            final String[] fromFieldNames = new String[]{DBAdapter.KEY_MESSAGE, DBAdapter.KEY_DATE, DBAdapter.KEY_REGNO};
            int[] toViewIDs = new int[]{R.id.txtMessage, R.id.txtDate, R.id.txtReg};
            final SimpleCursorAdapter myCursorAdapter;
            myCursorAdapter = new SimpleCursorAdapter(getBaseContext(), R.layout.custom_resource_layout, cursor, fromFieldNames, toViewIDs, 0);
            myList = (ListView) findViewById(R.id.inboxMyList);
            myList.setAdapter(myCursorAdapter);
        }
        else {
            TextView noMessages = (TextView)findViewById(R.id.inboxDisplayUser);
            noMessages.setText("You have no messages");
            Toast.makeText(this, "You have no messages.", Toast.LENGTH_SHORT).show();
        }
        myList.setOnItemClickListener(new AdapterView.OnItemClickListener() {
            @Override
            public void onItemClick(AdapterView<?> parent, View v, int position, long id) {
                showDialog();

            }
        });
    }

    /*
     * Brings up a dialog box that allows users the chance to give feedback on messages that they have recieved. 
     * The dialog box is a custom dialog box that is stored as custom_dialog_star_rating.xml and is used to create the 
     * layout of the form.
    */
    public void showDialog(){
        feedbackDialog = new Dialog(this);
        feedbackDialog.setContentView(R.layout.custom_dialog_star_rating);
        feedbackDialog.show();
    }

    public void onActionDialog(View view){
        respondToClick = (Button)feedbackDialog.findViewById(R.id.customDialogFeedbackButton);
        final RatingBar starsFeedback = (RatingBar)feedbackDialog.findViewById(R.id.customDialogRatingBar);
        final EditText feedbackComments = (EditText)feedbackDialog.findViewById(R.id.customDialogFurtherComments);

        respondToClick.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                float numStars = starsFeedback.getRating();
                String feedback = feedbackComments.getText().toString();

                Toast.makeText(Inbox.this, numStars + feedback, Toast.LENGTH_SHORT).show();

            }
        });
    }

    public void menu(View view){
        Intent menuIntent = new Intent(Inbox.this, MainMenu.class);
        startActivity(menuIntent);
    }



}
