package alex.carmessenger;

import android.content.Context;
import android.content.Intent;
import android.content.SharedPreferences;
import android.support.v7.app.AppCompatActivity;
import android.os.Bundle;
import android.view.Menu;
import android.view.MenuInflater;
import android.view.MenuItem;
import android.view.View;
import android.view.ViewGroup;
import android.widget.TextView;

public class MainMenu extends AppCompatActivity {
    public static String uniqueID;
    TextView mainMenuUsername;
    public static final String MyPREFERENCES = "MyPrefs" ;
    SharedPreferences sharedPref;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main_menu);
        sharedPref = getSharedPreferences(MyPREFERENCES, Context.MODE_PRIVATE);
        ViewGroup layout = (ViewGroup)findViewById(R.id.activity_main_menu);
        mainMenuUsername = new TextView(this);
        String newUser = sharedPref.getString(HomeScreen.username, "uniqueID");
        mainMenuUsername.setText(newUser);
        layout.addView(mainMenuUsername);
    }

    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        MenuInflater inflater = getMenuInflater();
        inflater.inflate(R.menu.menu_actions, menu);

        return super.onCreateOptionsMenu(menu);
    }

    public void sendMessage(View view){
        Intent sendMessageIntent = new Intent(MainMenu.this, sendMessage.class);
        startActivity(sendMessageIntent);
        finish();
    }
    public void inboxPage(View view){
        Intent inboxIntent = new Intent(MainMenu.this, Inbox.class);
        inboxIntent.putExtra("name", uniqueID);
        startActivity(inboxIntent);
        finish();
    }

    public void reportAccident(View view){
        Intent reportAccidentIntent = new Intent(MainMenu.this, ReportAccident.class);
        startActivity(reportAccidentIntent);
        finish();
    }

    public void securityTest(View view){
        Intent securityIntent = new Intent(MainMenu.this, security.class);
        startActivity(securityIntent);
        finish();
    }

    public void trafficInformation(View view){
        Intent TrafficIntent = new Intent(MainMenu.this, TrafficInformation.class);
        startActivity(TrafficIntent);
        finish();
    }

    public void wifiIntent(View view){
        Intent wifiIntent = new Intent(MainMenu.this, ServerActivity.class);
        startActivity(wifiIntent);
        finish();
    }

    public void webIntent(View view){
        Intent webIntent = new Intent(MainMenu.this, Client.class);
        startActivity(webIntent);
        finish();
    }

    @Override
    public boolean onOptionsItemSelected(MenuItem item) {
        switch (item.getItemId()) {
            case R.id.action_homeButton:
                Intent mainMenuIntent = new Intent(this, MainMenu.class);
                startActivity(mainMenuIntent);
                finish();
                return true;

            case R.id.action_new_message:
                Intent sendMessageIntent = new Intent(this, sendMessage.class);
                startActivity(sendMessageIntent);
                finish();
                return true;

            case R.id.action_logout:
                SharedPreferences sharedpreferences = getSharedPreferences(HomeScreen.MyPREFERENCES,
                        Context.MODE_PRIVATE);
                SharedPreferences.Editor editor = sharedpreferences.edit();
                editor.clear();
                editor.commit();
                Intent logoutIntent = new Intent(this, HomeScreen.class);
                startActivity(logoutIntent);
                finish();
                return true;

            default:
                // If we got here, the user's action was not recognized.
                // Invoke the superclass to handle it.
                return super.onOptionsItemSelected(item);

        }
    }
}
